<html><head>

<p class=MsoNormal><span lang=EN-US>Please note we provide an open source software notice along with this product and/or this product firmware (in the following just "this product"). The open source software licenses are granted by the respective right holders. And the open source licenses prevail all other license information with regard to the respective open source software contained in the product, including but not limited to End User Software Licensing Agreement. This notice is provided on behalf of Huawei Device Co., Ltd. and any of its local subsidiaries which may have provided this product to you in your local country.</span></p>


<p class=MsoNormal><b><span lang=EN-US style='font-size:16.0pt'>Warranty Disclaimer</span></b></p>


<p class=MsoNormal><b><span lang=EN-US style='text-transform:uppercase'>The open source software in this product is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY, without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the applicable licenses for more details.</span></b></p>


<p class=MsoNormal><b><span lang=EN-US style='font-size:16.0pt'>Copyright Notice and License Texts</span></b></p>


<style type="text/css">
body { padding: 0; font-family: sans-serif; }
.same-license { background-color: #eeeeee; border-top: 20px solid white; padding: 10px; }
.label { font-weight: bold; }
.file-list { margin-left: 1em; color: blue; }
</style>

</head><body topmargin="0" leftmargin="0" rightmargin="0" bottommargin="0">
<div class="toc">
<ul>
<li><a href="#id0">/protobuf</a></li>
</ul>
</div><!-- table of contents -->
<table cellpadding="0" cellspacing="0" border="0">
<tr id="id0"><td class="same-license">
<div class="label">Notices for Software(s):</div>
<div class="file-list">
/protobuf <br/>
</div><!-- file-list -->

<pre class="license-text">
Copyright 2008 Google Inc.  All rights reserved.
Copyright 2017 Google Inc.  All rights reserved.
returned by a get operation or modified by an update operation.
repeated values in the target resource will be overwritten by the new values.
Copyright 2014 Google Inc.  All rights reserved.
Author: kenton@google.com (Kenton Varda)
Author: kenton@google.com (Kenton Varda) and others
Copyright (c) 2006, Google Inc.
Copyright 2012 Google Inc.  All rights reserved.
Copyright 2008 Google Inc. All Rights Reserved.
Author: xpeng@google.com (Peter Peng)
Copyright 2005 Google Inc.
Author: lar@google.com (Laramie Leavitt)
Author: Anton Carver
Author: jrm@google.com (Jim Meehan)
Author: Maxim Lifantsev
Author: tgs@google.com (Tom Szymanski)
Author: ambrose@google.com (Ambrose Feinstein), kenton@google.com (Kenton Varda)
Author: xiaofeng@google.com (Feng Xiao)
Author: liujisi@google.com (Pherl Liu)
Author: dweis@google.com (Daniel Weis)
Author: jonp@google.com (Jon Perlow)
Copyright 2015 Google Inc.  All rights reserved.
Copyright 2007 Google Inc. All Rights Reserved.
Author: robinson@google.com (Will Robinson)
Author: seongkim@google.com (Seong Beom Kim)
Author: rennie@google.com (Jeffrey Rennie)
Author: jschorr@google.com (Joseph Schorr)
Copyright 2009 Google Inc.  All rights reserved.
Author: brianolson@google.com (Brian Olson)
Author: jasonh@google.com (Jason Hsueh)
Authors: wink@google.com (Wink Saville), kenton@google.com (Kenton Varda)
Author: laszlocsomor@google.com (Laszlo Csomor)
Adapted from the patch of kenton@google.com (Kenton Varda)
Author: ksroka@google.com (Krzysztof Sroka)
atenasio@google.com (Chris Atenasio) (ZigZag transform)
wink@google.com (Wink Saville) (refactored from wire_format.h)
Copyright 2016 Google Inc.  All rights reserved.
Author: haberman@google.com (Josh Haberman)
Author: petar@google.com (Petar Petrov)
Author: anuraag@google.com (Anuraag Agrawal)
Author: tibell@google.com (Johan Tibell)
Author: qrczak@google.com (Marcin Kowalczyk)
@author aappleby@google.com (Austin Appleby)
@author cfallin@google.com (Chris Fallin)
@author mwr@google.com (Mark Rawling)
Size of the entry (tag, size written by WriteMessage, data written by WriteMessage)
Copyright 2018 Google Inc.  All rights reserved.
Copyright 2019 Google Inc.  All rights reserved.
as written by &lt;see cref=&quot;WriteLength&quot;&gt;.
Fixed maps data corruption when the maps are modified by both reflection API


Copyright 2008 Google Inc.  All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

    * Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above
copyright notice, this list of conditions and the following disclaimer
in the documentation and/or other materials provided with the
distribution.
    * Neither the name of Google Inc. nor the names of its
contributors may be used to endorse or promote products derived from
this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
&quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Code generated by the Protocol Buffer compiler is owned by the owner
of the input file used when generating it.  This code is not
standalone and requires a support library to be linked with it.  This
support library is itself covered by the above license.

</pre><!-- license-text -->
</td></tr><!-- same-license -->



</table>
</body></html>
